Checkbox

A set of checkable buttons—known as radio buttons—where no more than one of the buttons can be checked at a time.
Installation
Expand

npx @left4code/cosmic-ui-cli@latest add checkbox
 
Expand

This writes the component and everything it imports, then installs the packages it needs. Run npx @left4code/cosmic-ui-cli@latest initfirst if you haven't already (it detects Vue automatically).

Install the following dependencies:

pnpm
npm
yarn
bun
yarn add @zag-js/checkbox @zag-js/vue

This component is built directly on the Zag.js state machine (not a wrapper). No Portal or presence composable needed, the check mark just toggles opacity, no exit animation. The hidden native input (needed for keyboard, focus and form submission) renders automatically insideCheckboxRoot. Vue SFCs can't export multiple components from one file, so Checkbox is a folder instead of a single file — copy all of it into your project.

components/ui/checkbox/context.ts
Expand

import type { InjectionKey, ComputedRef } from "vue";
import type * as checkbox from "@zag-js/checkbox";

type CheckboxApi = ComputedRef<ReturnType<typeof checkbox.connect>>;

const CheckboxApiKey: InjectionKey<CheckboxApi> = Symbol("checkbox-api");

export { CheckboxApiKey };
export type { CheckboxApi };
 
Expand
components/ui/checkbox/CheckboxRoot.vue
Expand

<script setup lang="ts">
import { computed, provide, useAttrs, useId } from "vue";
import { useMachine, normalizeProps } from "@zag-js/vue";
import * as checkbox from "@zag-js/checkbox";
import { twMerge } from "tailwind-merge";
import { CheckboxApiKey } from "./context";

defineOptions({ inheritAttrs: false });
const rawAttrs = useAttrs() as Partial<checkbox.Props> & { class?: string };
const id = useId();

const machineProps = computed(() => {
  const { class: _class, ...rest } = rawAttrs;
  return { id, ...rest };
});
const service = useMachine(checkbox.machine, machineProps);
const api = computed(() => checkbox.connect(service, normalizeProps));

provide(CheckboxApiKey, api);
</script>

<template>
  <label
    v-bind="api.getRootProps()"
    :class="twMerge(['flex gap-3.5 items-center cursor-pointer', rawAttrs.class])"
  >
    <slot />
    <input v-bind="api.getHiddenInputProps()" />
  </label>
</template>
 
Expand
components/ui/checkbox/CheckboxLabel.vue
Expand

<script setup lang="ts">
import { inject } from "vue";
import { twMerge } from "tailwind-merge";
import { CheckboxApiKey } from "./context";

const { class: className } = defineProps<{ class?: string }>();

const injectedApi = inject(CheckboxApiKey);
if (!injectedApi) throw new Error("Checkbox parts must be used within <CheckboxRoot>");
const api = injectedApi;
</script>

<template>
  <span v-bind="api.getLabelProps()" :class="twMerge(['order-2', className])">
    <slot />
  </span>
</template>
 
Expand
components/ui/checkbox/CheckboxControl.vue
Expand

<script setup lang="ts">
import { inject } from "vue";
import { twMerge } from "tailwind-merge";
import Frame, { parsePaths } from "@/components/ui/frame.vue";
import { Check } from "@lucide/vue";
import { CheckboxApiKey } from "./context";

const { class: className } = defineProps<{ class?: string }>();

const injectedApi = inject(CheckboxApiKey);
if (!injectedApi) throw new Error("Checkbox parts must be used within <CheckboxRoot>");
const api = injectedApi;

const framePaths = parsePaths(
  '[{"show":true,"style":{"strokeWidth":"1","stroke":"var(--color-frame-1-stroke)","fill":"var(--color-frame-1-fill)"},"path":[["M","50% - 28.125%","0"],["L","50% + 28.125%","0"],["L","100% + 0","50% - 28.125%"],["L","100% + 0","50% + 28.125%"],["L","50% + 28.125%","100% - 0"],["L","50% - 28.125%","100% + 0"],["L","0","50% + 28.125%"],["L","0","50% - 28.125%"],["L","50% - 28.125%","0"]]}]'
);
</script>

<template>
  <div
    v-bind="api.getControlProps()"
    :class="
      twMerge([
        'group relative size-5 flex items-center justify-center data-[state=checked]:drop-shadow-[0_0px_20px_var(--color-primary)]',
        '[--color-frame-1-stroke:var(--color-primary)]/80',
        '[--color-frame-1-fill:var(--color-primary)]/10',
        className,
      ])
    "
  >
    <Frame :paths="framePaths" />
    <Check
      class="group-data-[state=checked]:opacity-100 opacity-0 size-6 -mt-1 -mr-2 stroke-(--color-primary)/80 drop-shadow-[0_0px_2px_var(--color-primary)] transition-all duration-100"
    />
  </div>
</template>
 
Expand
components/ui/checkbox/index.ts
Expand

export { default as CheckboxRoot } from "./CheckboxRoot.vue";
export { default as CheckboxLabel } from "./CheckboxLabel.vue";
export { default as CheckboxControl } from "./CheckboxControl.vue";
 
Expand

Update the import paths to match your project setup.

Usage
Expand

import { CheckboxRoot, CheckboxLabel, CheckboxControl } from "@/components/ui/checkbox";
 
Expand
Expand

<CheckboxRoot>
  <CheckboxLabel>Accept terms and conditions</CheckboxLabel>
  <CheckboxControl />
</CheckboxRoot>
 
Expand
Powered by synthetic caffeine · Deployed by Left4code · Signal traceable on GitHub.

Checkbox

A set of checkable buttons—known as radio buttons—where no more than one of the buttons can be checked at a time.
Installation
Expand

npx @left4code/cosmic-ui-cli@latest add checkbox
 
Expand

This writes the component and everything it imports, then installs the packages it needs. Run npx @left4code/cosmic-ui-cli@latest initfirst if you haven't already.

Install the following dependencies:

pnpm
npm
yarn
bun
yarn add @zag-js/checkbox @zag-js/react

This component is built directly on the Zag.js state machine (not a wrapper). No Portal or presence hook needed, the check mark just toggles opacity, no exit animation. The hidden native input (needed for keyboard, focus and form submission) renders automatically inside CheckboxRoot. Copy and paste the following code into your project.

components/ui/checkbox.tsx
Expand

import { createContext, useContext, useId } from "react";
import { twMerge } from "tailwind-merge";
import { useMachine, normalizeProps } from "@zag-js/react";
import * as checkbox from "@zag-js/checkbox";
import { Frame, parsePaths } from "@/components/ui/frame";
import { Check } from "lucide-react";

const CheckboxContext = createContext<ReturnType<typeof checkbox.connect> | null>(
  null
);

function useCheckboxContext() {
  const api = useContext(CheckboxContext);
  if (!api) throw new Error("Checkbox parts must be used within <CheckboxRoot>");
  return api;
}

function CheckboxRoot({
  children,
  className,
  ...rest
}: React.PropsWithChildren<Partial<checkbox.Props> & { className?: string }>) {
  const service = useMachine(checkbox.machine, { id: useId(), ...rest });
  const api = checkbox.connect(service, normalizeProps);

  return (
    <CheckboxContext.Provider value={api}>
      <label
        {...api.getRootProps()}
        className={twMerge(["flex gap-3.5 items-center cursor-pointer", className])}
      >
        {children}
        <input {...api.getHiddenInputProps()} />
      </label>
    </CheckboxContext.Provider>
  );
}

function CheckboxLabel({
  children,
  className,
}: React.PropsWithChildren<{ className?: string }>) {
  const api = useCheckboxContext();

  return (
    <span {...api.getLabelProps()} className={twMerge(["order-2", className])}>
      {children}
    </span>
  );
}

function CheckboxControl({ className }: { className?: string }) {
  const api = useCheckboxContext();

  return (
    <div
      {...api.getControlProps()}
      className={twMerge([
        "group relative size-5 flex items-center justify-center data-[state=checked]:drop-shadow-[0_0px_20px_var(--color-primary)]",
        "[--color-frame-1-stroke:var(--color-primary)]/80",
        "[--color-frame-1-fill:var(--color-primary)]/10",
        className,
      ])}
    >
      <Frame
        paths={parsePaths(
          '[{"show":true,"style":{"strokeWidth":"1","stroke":"var(--color-frame-1-stroke)","fill":"var(--color-frame-1-fill)"},"path":[["M","50% - 28.125%","0"],["L","50% + 28.125%","0"],["L","100% + 0","50% - 28.125%"],["L","100% + 0","50% + 28.125%"],["L","50% + 28.125%","100% - 0"],["L","50% - 28.125%","100% + 0"],["L","0","50% + 28.125%"],["L","0","50% - 28.125%"],["L","50% - 28.125%","0"]]}]'
        )}
      />
      <Check className="group-data-[state=checked]:opacity-100 opacity-0 size-6 -mt-1 -mr-2 stroke-(--color-primary)/80 drop-shadow-[0_0px_2px_var(--color-primary)] transition-all duration-100" />
    </div>
  );
}

export { CheckboxRoot, CheckboxLabel, CheckboxControl };
 
Expand

Update the import paths to match your project setup.

Usage
Expand

import {
  CheckboxRoot,
  CheckboxLabel,
  CheckboxControl,
} from "@/components/ui/checkbox";
 
Expand
Expand

<CheckboxRoot>
  <CheckboxLabel>Accept terms and conditions</CheckboxLabel>
  <CheckboxControl />
</CheckboxRoot>
 
Expand
Powered by synthetic caffeine · Deployed by Left4code · Signal traceable on GitHub.